
# #=+--+=#=+--             Black Swift Technologies SDK           --+=#=+--+=# #
#               Copyright (C) 2025 Black Swift Technologies LLC.               #
#                             All Rights Reserved.                             #
#                                                                              #
#    This program is free software: you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License version 2 as         #
#    published by the Free Software Foundation.                                #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                              #
#                                 Jack Elston                                  #
#                          elstonj@blackswifttech.com                          #
#                                                                              #
#                                  Ben Busby                                   #
#                         ben.busby@blackswifttech.com                         #
#                                                                              #
# *#=+--+=#=+--                 --+=#=+--+=#=+--                 --+=#=+--+=#* #

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# AUTOGENERATED -- DO NOT EDIT
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

from .comm_packets import *
from .gcs import *
from .payload import *
from . import fixedwing
from . import multicopter
from . import vtol
from . import tailsitter
from .canpackets import *

packet_mapping = {
    # GCS Packets
    PacketTypes.TELEMETRY_GCS.value: GCSStatus,
    PacketTypes.TELEMETRY_GCS_LOCATION.value: TelemetryGCS,
    PacketTypes.TELEMETRY_GCS_SVIN.value: GCSSurveyIn,

    # Aircraft Packets
    PacketTypes.ACTUATORS_CALIBRATION.value: ActuatorCalibration,
    PacketTypes.ACTUATORS_VALUES.value: Actuators,
    PacketTypes.CONTROL_COMMAND.value: Command,
    PacketTypes.CONTROL_PID.value: PID,
    PacketTypes.DUBIN_PATH.value: DubinsPath,
    PacketTypes.FLIGHT_PLAN_MAP.value: FlightPlanMap,
    PacketTypes.FLIGHT_PLAN_WAYPOINT.value: Waypoint,
    PacketTypes.HANDSET_CALIBRATION.value: HandsetCalibration,
    PacketTypes.INPUT_HANDSET_VALUES.value: HandsetValues,
    PacketTypes.INPUT_JOYSTICK_VALUES.value: TabletJoystick,
    PacketTypes.SENSORS_ACCELEROMETER.value: ThreeAxisSensor,
    PacketTypes.SENSORS_ADSB.value: ADSB,
    PacketTypes.SENSORS_AGL.value: SingleValueSensor,
    PacketTypes.SENSORS_AIR_TEMPERATURE.value: SingleValueSensor,
    PacketTypes.SENSORS_BOARD_ORIENTATION.value: AxisMapping,
    PacketTypes.SENSORS_CALIBRATE.value: CalibrateSensor,
    PacketTypes.SENSORS_DYNAMIC_PRESSURE.value: Pressure,
    PacketTypes.SENSORS_DYNP_CALIBRATION.value: SingleAxisSensorCalibration,
    PacketTypes.SENSORS_GNSS_ORIENTATION.value: AxisMapping,
    PacketTypes.SENSORS_GNSS_RTCM.value: RTCM,
    PacketTypes.SENSORS_GPS.value: GPS,
    PacketTypes.SENSORS_GYROSCOPE.value: ThreeAxisSensor,
    PacketTypes.SENSORS_GYRO_CALIBRATION.value: ThreeAxisSensorCalibration,
    PacketTypes.SENSORS_IMU.value: IMU,
    PacketTypes.SENSORS_MAGNETOMETER.value: ThreeAxisSensor,
    PacketTypes.SENSORS_MAG_CALIBRATION.value: ThreeAxisSensorCalibration,
    PacketTypes.SENSORS_MAG_CURRENT_CAL.value: ThreeAxisFirstOrderCorrection,
    PacketTypes.SENSORS_MHP.value: MHP,
    PacketTypes.SENSORS_MHP.value: MHP9HSensors,
    PacketTypes.SENSORS_MHP.value: MHP9HTiming,
    PacketTypes.SENSORS_MHP.value: MHPSensors,
    PacketTypes.SENSORS_MHP.value: MHPSensorsGNSS,
    PacketTypes.SENSORS_MHP.value: MHPTiming,
    PacketTypes.SENSORS_STATIC_PRESSURE.value: Pressure,
    PacketTypes.STATE_ESTIMATOR_PARAM.value: EstimatorParameters,
    PacketTypes.STATE_STATE.value: State,
    PacketTypes.SYSTEM_HARDWARE_ERROR.value: HardwareError,
    PacketTypes.SYSTEM_HEALTH_AND_STATUS.value: SystemStatus,
    PacketTypes.SYSTEM_INITIALIZE.value: SystemInitialize,
    PacketTypes.SYSTEM_POWER_ON.value: PowerOn,
    PacketTypes.TELEMETRY_CONTROL.value: TelemetryControl,
    PacketTypes.TELEMETRY_DEPLOYMENT_TUBE.value: DeploymentTube,
    PacketTypes.TELEMETRY_ORIENTATION.value: TelemetryOrientation,
    PacketTypes.TELEMETRY_POSITION.value: TelemetryPosition,
    PacketTypes.TELEMETRY_PRESSURE.value: TelemetryPressure,
    PacketTypes.TELEMETRY_SYSTEM.value: TelemetrySystem,

    # Payload Packets
    PacketTypes.PAYLOAD_DATA_CHANNEL_0.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_1.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_2.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_3.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_4.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_5.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_6.value: UserPayload,
    PacketTypes.PAYLOAD_DATA_CHANNEL_7.value: UserPayload,
    PacketTypes.PAYLOAD_CAMERA_TAG.value: CameraTag,
    PacketTypes.PAYLOAD_LDCR.value: LDCR,
    PacketTypes.PAYLOAD_NDVI.value: NDVI,
    PacketTypes.PAYLOAD_PARAMS.value: PayloadParam,
    PacketTypes.PAYLOAD_S0_SENSORS.value: S0Sensors,
    PacketTypes.PAYLOAD_SERIAL.value: PayloadSerial,
    PacketTypes.PAYLOAD_STATUS.value: PayloadStatus,
    PacketTypes.PAYLOAD_TRIGGER.value: PayloadTrigger,
    PacketTypes.TELEMETRY_PAYLOAD.value: TelemetryPayload,
}

fw_mapping = {
    PacketTypes.ACTUATORS_MIXING_PARAMS.value: fixedwing.SurfaceMixing,
    PacketTypes.CONTROL_FILTER_PARAMS.value: fixedwing.FilterParameters,
    PacketTypes.CONTROL_FLIGHT_PARAMS.value: fixedwing.FlightControlParameters,
    PacketTypes.MISSION_PARAMETERS.value: fixedwing.MissionParameters,
    PacketTypes.VEHICLE_LAND_PARAMS.value: fixedwing.LandingParameters,
    PacketTypes.VEHICLE_LAUNCH_PARAMS.value: fixedwing.LaunchParameters,
    PacketTypes.VEHICLE_LIMITS.value: fixedwing.VehicleLimits,
    PacketTypes.VEHICLE_PARAMS.value: fixedwing.VehicleParameters,
}

mr_mapping = {
    PacketTypes.ACTUATORS_ROTOR_PARAMS.value: multicopter.RotorParameters,
    PacketTypes.CONTROL_FLIGHT_PARAMS.value: multicopter.FlightControlParameters,
    PacketTypes.MISSION_PARAMETERS.value: multicopter.MissionParameters,
    PacketTypes.VEHICLE_LAND_PARAMS.value: multicopter.LandingParameters,
    PacketTypes.VEHICLE_LAUNCH_PARAMS.value: multicopter.LaunchParameters,
    PacketTypes.VEHICLE_LIMITS.value: multicopter.VehicleLimits,
    PacketTypes.VEHICLE_PARAMS.value: multicopter.VehicleParameters,
}

vt_mapping = {
    PacketTypes.ACTUATORS_ROTOR_PARAMS.value: vtol.RotorParameters,
    PacketTypes.CONTROL_FLIGHT_PARAMS.value: vtol.FlightControlParameters,
    PacketTypes.MISSION_PARAMETERS.value: vtol.MissionParameters,
    PacketTypes.VEHICLE_LAND_PARAMS.value: vtol.LandingParameters,
    PacketTypes.VEHICLE_LAUNCH_PARAMS.value: vtol.LaunchParameters,
    PacketTypes.VEHICLE_LIMITS.value: vtol.VehicleLimits,
    PacketTypes.VEHICLE_PARAMS.value: vtol.VehicleParameters,
}

ts_mapping = {
    PacketTypes.ACTUATORS_ROTOR_PARAMS.value: tailsitter.RotorParameters,
    PacketTypes.CONTROL_FLIGHT_PARAMS.value: tailsitter.FlightControlParameters,
    PacketTypes.MISSION_PARAMETERS.value: tailsitter.MissionParameters,
    PacketTypes.VEHICLE_LAND_PARAMS.value: tailsitter.LandingParameters,
    PacketTypes.VEHICLE_LAUNCH_PARAMS.value: tailsitter.LaunchParameters,
    PacketTypes.VEHICLE_LIMITS.value: tailsitter.VehicleLimits,
    PacketTypes.VEHICLE_PARAMS.value: tailsitter.VehicleParameters,
}

primitive_pkts = [
    PacketTypes.LAST_MAPPING_WAYPOINT.value,
]

ignore_pkts = [
    PacketTypes.TELEMETRY_HEARTBEAT.value,
]

can_actuators = CAN_Actuator()

def standard_handler(pkt, sys_time=0, vehicle_type=VehicleType.VEHICLE_UNKNOWN):
    packet_data = None

    pkt_map = packet_mapping

    if pkt.TYPE not in pkt_map:
        if vehicle_type != VehicleType.VEHICLE_UNKNOWN:
            # FIXED_WING
            if vehicle_type.value == 1 and pkt.TYPE in fw_mapping:
                pkt_map = fw_mapping
            # MULTI_COPTER
            elif vehicle_type.value == 2 and pkt.TYPE in mr_mapping:
                pkt_map = mr_mapping
            # VTOL
            elif vehicle_type.value == 6 and pkt.TYPE in vt_mapping:
                pkt_map = vt_mapping
            # TAIL_SITTER
            elif vehicle_type.value == 5 and pkt.TYPE in ts_mapping:
                pkt_map = ts_mapping
            else:
                if pkt.TYPE not in ignore_pkts:
                    print(f'Parsing not set up for {vehicle_type.name} packet {pkt.TYPE}...')
                return None, sys_time
        else:
            if pkt.TYPE != PacketTypes.TELEMETRY_HEARTBEAT.value:
                print(f'Parsing not set up for packet {pkt.TYPE}...')
            return None, sys_time

    try:
        if pkt.TYPE >= PacketTypes.PAYLOAD_DATA_CHANNEL_0.value:
            pkt_map[pkt.TYPE].buffer = [None] * 64

        if pkt_map[pkt.TYPE] == int:
            packet_data = int.from_bytes(bytearray(pkt.DATA))
        else:
            pkt_cls = pkt_map[pkt.TYPE]()
            pkt_cls.parse(bytearray(pkt.DATA))
            packet_data = pkt_cls
    except BufferError as ErrorMessage:
        print(ErrorMessage)
        return None, sys_time
    except ValueError as ErrorMessage:
        print(ErrorMessage)
        return None, sys_time

    if hasattr(packet_data, "system_time"):
        return packet_data, packet_data.system_time
    elif pkt.TYPE not in primitive_pkts:
        packet_data.set_system_time(sys_time)
    return packet_data, sys_time

